diff --git a/libs/freetdm/src/ftmod/ftmod_isdn/ftmod_isdn.c b/libs/freetdm/src/ftmod/ftmod_isdn/ftmod_isdn.c
index 3715e98..7a28107 100644
--- a/libs/freetdm/src/ftmod/ftmod_isdn/ftmod_isdn.c
+++ b/libs/freetdm/src/ftmod/ftmod_isdn/ftmod_isdn.c
@@ -664,7 +875,12 @@ static L3INT ftdm_isdn_931_34(void *pvt, L2UCHAR *msg, L2INT mlen)
 					ftdm_set_state_locked(ftdmchan, FTDM_CHANNEL_STATE_RESTART);
 				} else {
 					uint32_t i;
+
 					for (i = 1; i < span->chan_count; i++) {
+						/* Skip channels that are down and D-Channels (#OpenZAP-39) */
+						if (span->channels[i]->state == FTDM_CHANNEL_STATE_DOWN || span->channels[i]->type == FTDM_CHAN_TYPE_DQ921)
+							continue;
+
 						ftdm_set_state_locked((span->channels[i]), FTDM_CHANNEL_STATE_RESTART);
 					}
 				}
@@ -699,7 +915,7 @@ static L3INT ftdm_isdn_931_34(void *pvt, L2UCHAR *msg, L2INT mlen)
 						sig.channel->caller_data.hangup_cause = (cause) ? cause->Value : FTDM_CAUSE_NORMAL_UNSPECIFIED;
 
 						sig.event_id = FTDM_SIGEVENT_STOP;
-						status = ftdm_span_send_signal(ftdmchan->span, &sig);
+						status = isdn_data->sig_cb(&sig);
 
 						ftdm_log(FTDM_LOG_DEBUG, "Received %s in state %s, requested hangup for channel %d:%d\n", what, ftdm_channel_state2str(ftdmchan->state), ftdmchan->span_id, chan_id);
 					}
@@ -741,17 +957,21 @@ static L3INT ftdm_isdn_931_34(void *pvt, L2UCHAR *msg, L2INT mlen)
 			}
 			break;
 		case Q931mes_CONNECT:
+#if 0	/* Handled by new event code */
 			{
 				if (ftdmchan) {
 					ftdm_set_state_locked(ftdmchan, FTDM_CHANNEL_STATE_UP);
 
+#if 0	/* Auto-Ack is enabled, we actually don't need this */
 					gen->MesType = Q931mes_CONNECT_ACKNOWLEDGE;
 					gen->CRVFlag = 0;	/* outbound */
-					Q931Rx43(&isdn_data->q931, (L3UCHAR *) gen, gen->Size);
+					Q931Rx43(&isdn_data->q931, gen, gen->Size);
+#endif
 				} else {
 					ftdm_log(FTDM_LOG_CRIT, "Received Connect with no matching channel %d\n", chan_id);
 				}
 			}
+#endif
 			break;
 		case Q931mes_SETUP:
 			{
@@ -771,13 +991,13 @@ static L3INT ftdm_isdn_931_34(void *pvt, L2UCHAR *msg, L2INT mlen)
 									ftdm_channel_state2str(ftdmchan->state));
 					break;
 				}
-				
+
 				ftdmchan = NULL;
 				/*
 				 * Channel selection for incoming calls:
 				 */
 				if (FTDM_SPAN_IS_NT(span) && chan_hunt) {
-					uint32_t x;
+					int x;
 
 					/*
 					 * In NT-mode with channel selection "any",
@@ -865,14 +1085,21 @@ static L3INT ftdm_isdn_931_34(void *pvt, L2UCHAR *msg, L2INT mlen)
 							memset(ftdmchan->mod_data, 0, sizeof(ftdm_isdn_bchan_data_t));
 						}
 
-						ftdm_set_string(ftdmchan->caller_data.cid_num.digits, (char *)callingnum->Digit);
-						ftdm_set_string(ftdmchan->caller_data.cid_name, (char *)callingnum->Digit);
-						ftdm_set_string(ftdmchan->caller_data.ani.digits, (char *)callingnum->Digit);
+						/* copy number readd prefix as needed */
+						isdn_get_number(callingnum, ftdmchan->caller_data.cid_num.digits);
+						isdn_get_number(callingnum, ftdmchan->caller_data.cid_name);
+						isdn_get_number(callingnum, ftdmchan->caller_data.ani.digits);
+
+//						ftdm_set_string(ftdmchan->caller_data.cid_num.digits, (char *)callingnum->Digit);
+//						ftdm_set_string(ftdmchan->caller_data.cid_name, (char *)callingnum->Digit);
+//						ftdm_set_string(ftdmchan->caller_data.ani.digits, (char *)callingnum->Digit);
 						if (!overlap_dial) {
-							ftdm_set_string(ftdmchan->caller_data.dnis.digits, (char *)callednum->Digit);
+//							ftdm_set_string(ftdmchan->caller_data.dnis.digits, (char *)callednum->Digit);
+							isdn_get_number(callednum, ftdmchan->caller_data.dnis.digits);
 						}
-
+#ifdef __TODO_OR_REMOVE__
 						ftdmchan->caller_data.CRV = gen->CRV;
+#endif
 						if (cplen > sizeof(ftdmchan->caller_data.raw_data)) {
 							cplen = sizeof(ftdmchan->caller_data.raw_data);
 						}
@@ -880,8 +1107,8 @@ static L3INT ftdm_isdn_931_34(void *pvt, L2UCHAR *msg, L2INT mlen)
 						memcpy(ftdmchan->caller_data.raw_data, msg, cplen);
 						ftdmchan->caller_data.raw_data_len = cplen;
 						fail = 0;
-					} 
-				} 
+					}
+				}
 
 				if (fail) {
 					Q931ie_Cause cause;
@@ -895,8 +1122,8 @@ static L3INT ftdm_isdn_931_34(void *pvt, L2UCHAR *msg, L2INT mlen)
 					//should we be casting here.. or do we need to translate value?
 					cause.Value = (unsigned char)((fail_cause) ? fail_cause : FTDM_CAUSE_WRONG_CALL_STATE);
 					*cause.Diag = '\0';
-					gen->Cause = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &cause);
-					Q931Rx43(&isdn_data->q931, (L3UCHAR *) gen, gen->Size);
+					gen->Cause = Q931AppendIE(gen, (L3UCHAR *) &cause);
+					Q931Rx43(&isdn_data->q931, gen, gen->Size);
 
 					if (gen->CRV) {
 						Q931ReleaseCRV(&isdn_data->q931, gen->CRV);
@@ -907,7 +1134,7 @@ static L3INT ftdm_isdn_931_34(void *pvt, L2UCHAR *msg, L2INT mlen)
 					} else {
 						ftdm_log(FTDM_LOG_CRIT, "Failed to open channel for new setup message\n");
 					}
-					
+
 				} else {
 					Q931ie_ChanID ChanID;
 
@@ -924,7 +1151,7 @@ static L3INT ftdm_isdn_931_34(void *pvt, L2UCHAR *msg, L2INT mlen)
 					} else {
 						ChanID.InfoChanSel = (unsigned char)ftdmchan->chan_id & 0x03;	/* None = 0, B1 = 1, B2 = 2, Any = 3 */
 					}
-					gen->ChanID = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &ChanID);
+					gen->ChanID = Q931AppendIE(gen, (L3UCHAR *) &ChanID);
 
 					if (overlap_dial) {
 						Q931ie_ProgInd progress;
@@ -934,17 +1161,17 @@ static L3INT ftdm_isdn_931_34(void *pvt, L2UCHAR *msg, L2INT mlen)
 						 */
 						progress.IEId = Q931ie_PROGRESS_INDICATOR;
 						progress.Size = sizeof(Q931ie_ProgInd);
-						progress.CodStand = Q931_CODING_ITU;	/* ITU */ 
+						progress.CodStand = Q931_CODING_ITU;	/* ITU */
 						progress.Location = 1;	/* private network serving the local user */
 						progress.ProgDesc = 8;	/* call is not end-to-end isdn = 1, in-band information available = 8 */
-						gen->ProgInd = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &progress);
+						gen->ProgInd = Q931AppendIE(gen, (L3UCHAR *) &progress);
 
 						/*
 						 * Send SETUP ACK
 						 */
 						gen->MesType = Q931mes_SETUP_ACKNOWLEDGE;
 						gen->CRVFlag = 1;	/* inbound call */
-						Q931Rx43(&isdn_data->q931, (L3UCHAR *) gen, gen->Size);
+						Q931Rx43(&isdn_data->q931, gen, gen->Size);
 
 						ftdm_set_state_locked(ftdmchan, FTDM_CHANNEL_STATE_DIALTONE);
 					} else {
@@ -999,7 +1226,7 @@ static L3INT ftdm_isdn_931_34(void *pvt, L2UCHAR *msg, L2INT mlen)
 							}
 
 							/* TODO: make this more safe with strncat() */
-							pos = (int)strlen(ftdmchan->caller_data.dnis.digits);
+							pos = strlen(ftdmchan->caller_data.dnis.digits);
 							strcat(&ftdmchan->caller_data.dnis.digits[pos],    (char *)callednum->Digit);
 
 							/* update timer */
@@ -1020,61 +1247,6 @@ static L3INT ftdm_isdn_931_34(void *pvt, L2UCHAR *msg, L2INT mlen)
 			}
 			break;
 
-		case Q931mes_STATUS_ENQUIRY:
-			{
-				/*
-				 * !! HACK ALERT !!
-				 *
-				 * Map FreeTDM channel states to Q.931 states
-				 */
-				Q931ie_CallState state;
-				Q931ie_Cause cause;
-
-				gen->MesType = Q931mes_STATUS;
-				gen->CRVFlag = gen->CRVFlag ? 0 : 1;
-
-				state.CodStand  = Q931_CODING_ITU;	/* ITU-T */
-				state.CallState = Q931_U0;		/* Default: Null */
-
-				cause.IEId = Q931ie_CAUSE;
-				cause.Size = sizeof(Q931ie_Cause);
-				cause.CodStand = Q931_CODING_ITU;	/* ITU */
-				cause.Location = 1;	/* private network */
-				cause.Recom    = 1;	/* */
-				*cause.Diag    = '\0';
-
-				if(ftdmchan) {
-					switch(ftdmchan->state) {
-					case FTDM_CHANNEL_STATE_UP:
-						state.CallState = Q931_U10;	/* Active */
-						break;
-					case FTDM_CHANNEL_STATE_RING:
-						state.CallState = Q931_U6;	/* Call present */
-						break;
-					case FTDM_CHANNEL_STATE_DIALING:
-						state.CallState = Q931_U1;	/* Call initiated */
-						break;
-					case FTDM_CHANNEL_STATE_DIALTONE:
-						state.CallState = Q931_U25;	/* Overlap receiving */
-						break;
-
-					/* TODO: map missing states */
-
-					default:
-						state.CallState = Q931_U0;
-					}
-
-					cause.Value = 30;	/* response to STATUS ENQUIRY */
-				} else {
-					cause.Value = 98;	/* */
-				}
-
-				gen->CallState = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &state);
-				gen->Cause     = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &cause);
-				Q931Rx43(&isdn_data->q931, (L3UCHAR *) gen, gen->Size);
-			}
-			break;
-
 		default:
 			ftdm_log(FTDM_LOG_CRIT, "Received unhandled message %d (%#x)\n", (int)gen->MesType, (int)gen->MesType);
 			break;
@@ -1084,17 +1256,10 @@ static L3INT ftdm_isdn_931_34(void *pvt, L2UCHAR *msg, L2INT mlen)
 	return 0;
 }
 
-/**
- * \brief Handler for Q921 read event
- * \param pvt Span were message is coming from
- * \param ind Q921 indication
- * \param tei Terminal Endpoint Identifier
- * \param msg Message string
- * \param mlen Message string length
- * \return 0 on success, 1 on failure
- */
 static int ftdm_isdn_921_23(void *pvt, Q921DLMsg_t ind, L2UCHAR tei, L2UCHAR *msg, L2INT mlen)
 {
+	ftdm_span_t *span = pvt;
+	ftdm_isdn_data_t *isdn_data = span->signal_data;
 	int ret, offset = (ind == Q921_DL_DATA) ? 4 : 3;
 	char bb[4096] = "";
 
@@ -1102,20 +1267,14 @@ static int ftdm_isdn_921_23(void *pvt, Q921DLMsg_t ind, L2UCHAR tei, L2UCHAR *ms
 	case Q921_DL_DATA:
 	case Q921_DL_UNIT_DATA:
 		print_hex_bytes(msg + offset, mlen - offset, bb, sizeof(bb));
-#ifdef HAVE_LIBPCAP
-		/*Q931ToPcap*/
-                if(do_q931ToPcap==1){
-			ftdm_span_t *span = (ftdm_span_t *) pvt;
-                        if(writeQ931PacketToPcap(msg + offset, mlen - offset, span->span_id, 1) != FTDM_SUCCESS){
-                                ftdm_log(FTDM_LOG_WARNING, "Couldn't write Q931 buffer to pcap file!\n");
-                        }
-                }
-                /*Q931ToPcap done*/
+		ftdm_log(FTDM_LOG_DEBUG, "READ %d\n%s\n%s\n\n", (int)mlen - offset, LINE, bb);
+#ifdef HAVE_PCAP
+		if (isdn_pcap_capture_l3only(isdn_data)) {
+			isdn_pcap_write(isdn_data, msg, mlen, (ind == Q921_DL_UNIT_DATA) ? ISDN_PCAP_INCOMING_BCAST : ISDN_PCAP_INCOMING);
+		}
 #endif
-		ftdm_log(FTDM_LOG_DEBUG, "READ %d\n%s\n%s\n\n\n", (int)mlen - offset, LINE, bb);
-	
 	default:
-		ret = Q931Rx23(pvt, ind, tei, msg, mlen);
+		ret = Q931Rx23(&isdn_data->q931, ind, tei, msg, mlen);
 		if (ret != 0)
 			ftdm_log(FTDM_LOG_DEBUG, "931 parse error [%d] [%s]\n", ret, q931_error_to_name(ret));
 		break;
@@ -1124,35 +1283,22 @@ static int ftdm_isdn_921_23(void *pvt, Q921DLMsg_t ind, L2UCHAR tei, L2UCHAR *ms
 	return ((ret >= 0) ? 1 : 0);
 }
 
-/**
- * \brief Handler for Q921 write event
- * \param pvt Span were message is coming from
- * \param msg Message string
- * \param mlen Message string length
- * \return 0 on success, -1 on failure
- */
 static int ftdm_isdn_921_21(void *pvt, L2UCHAR *msg, L2INT mlen)
 {
 	ftdm_span_t *span = (ftdm_span_t *) pvt;
 	ftdm_size_t len = (ftdm_size_t) mlen;
 	ftdm_isdn_data_t *isdn_data = span->signal_data;
 
-#ifdef IODEBUG
-	char bb[4096] = "";
-	print_hex_bytes(msg, len, bb, sizeof(bb));
-	print_bits(msg, (int)len, bb, sizeof(bb), FTDM_ENDIAN_LITTLE, 0);
-	ftdm_log(FTDM_LOG_DEBUG, "WRITE %d\n%s\n%s\n\n", (int)len, LINE, bb);
+	assert(span != NULL);
 
+#ifdef HAVE_PCAP
+	if (isdn_pcap_capture_both(isdn_data)) {
+		isdn_pcap_write(isdn_data, msg, mlen, ISDN_PCAP_OUTGOING);
+	}
 #endif
-
-	assert(span != NULL);
 	return ftdm_channel_write(isdn_data->dchan, msg, len, &len) == FTDM_SUCCESS ? 0 : -1;
 }
 
-/**
- * \brief Handler for channel state change
- * \param ftdmchan Channel to handle
- */
 static __inline__ void state_advance(ftdm_channel_t *ftdmchan)
 {
 	Q931mes_Generic *gen = (Q931mes_Generic *) ftdmchan->caller_data.raw_data;
@@ -1160,7 +1306,7 @@ static __inline__ void state_advance(ftdm_channel_t *ftdmchan)
 	ftdm_sigmsg_t sig;
 	ftdm_status_t status;
 
-	ftdm_log(FTDM_LOG_DEBUG, "%d:%d STATE [%s]\n", 
+	ftdm_log(FTDM_LOG_DEBUG, "%d:%d STATE [%s]\n",
 			ftdmchan->span_id, ftdmchan->chan_id, ftdm_channel_state2str(ftdmchan->state));
 
 	memset(&sig, 0, sizeof(sig));
@@ -1186,11 +1332,15 @@ static __inline__ void state_advance(ftdm_channel_t *ftdmchan)
 		{
 			if (ftdm_test_flag(ftdmchan, FTDM_CHANNEL_OUTBOUND)) {
 				sig.event_id = FTDM_SIGEVENT_PROGRESS;
-				if ((status = ftdm_span_send_signal(ftdmchan->span, &sig) != FTDM_SUCCESS)) {
+				if ((status = isdn_data->sig_cb(&sig) != FTDM_SUCCESS)) {
 					ftdm_set_state_locked(ftdmchan, FTDM_CHANNEL_STATE_HANGUP);
 				}
 			} else {
+				int crv = gen->CRV;
+
+				Q931InitMesGeneric(gen);
 				gen->MesType = Q931mes_CALL_PROCEEDING;
+				gen->CRV     = crv;
 				gen->CRVFlag = 1;	/* inbound */
 
 				if (FTDM_SPAN_IS_NT(ftdmchan->span)) {
@@ -1210,10 +1360,10 @@ static __inline__ void state_advance(ftdm_channel_t *ftdmchan)
 					} else {
 						ChanID.InfoChanSel = (unsigned char)ftdmchan->chan_id & 0x03;	/* None = 0, B1 = 1, B2 = 2, Any = 3 */
 					}
-					gen->ChanID = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &ChanID);
+					gen->ChanID = Q931AppendIE(gen, (L3UCHAR *) &ChanID);
 				}
 
-				Q931Rx43(&isdn_data->q931, (void *)gen, gen->Size);
+				Q931Rx43(&isdn_data->q931, gen, gen->Size);
 			}
 		}
 		break;
@@ -1230,7 +1380,7 @@ static __inline__ void state_advance(ftdm_channel_t *ftdmchan)
 		{
 			if (!ftdm_test_flag(ftdmchan, FTDM_CHANNEL_OUTBOUND)) {
 				sig.event_id = FTDM_SIGEVENT_START;
-				if ((status = ftdm_span_send_signal(ftdmchan->span, &sig) != FTDM_SUCCESS)) {
+				if ((status = isdn_data->sig_cb(&sig) != FTDM_SUCCESS)) {
 					ftdm_set_state_locked(ftdmchan, FTDM_CHANNEL_STATE_HANGUP);
 				}
 			}
@@ -1240,7 +1390,7 @@ static __inline__ void state_advance(ftdm_channel_t *ftdmchan)
 		{
 			ftdmchan->caller_data.hangup_cause = FTDM_CAUSE_NORMAL_UNSPECIFIED;
 			sig.event_id = FTDM_SIGEVENT_RESTART;
-			status = ftdm_span_send_signal(ftdmchan->span, &sig);
+			status = isdn_data->sig_cb(&sig);
 			ftdm_set_state_locked(ftdmchan, FTDM_CHANNEL_STATE_DOWN);
 		}
 		break;
@@ -1248,7 +1398,7 @@ static __inline__ void state_advance(ftdm_channel_t *ftdmchan)
 		{
 			if (ftdm_test_flag(ftdmchan, FTDM_CHANNEL_OUTBOUND)) {
 				sig.event_id = FTDM_SIGEVENT_PROGRESS_MEDIA;
-				if ((status = ftdm_span_send_signal(ftdmchan->span, &sig) != FTDM_SUCCESS)) {
+				if ((status = isdn_data->sig_cb(&sig) != FTDM_SUCCESS)) {
 					ftdm_set_state_locked(ftdmchan, FTDM_CHANNEL_STATE_HANGUP);
 				}
 			} else {
@@ -1260,7 +1410,7 @@ static __inline__ void state_advance(ftdm_channel_t *ftdmchan)
 				}
 				gen->MesType = Q931mes_ALERTING;
 				gen->CRVFlag = 1;	/* inbound call */
-				Q931Rx43(&isdn_data->q931, (void *)gen, gen->Size);
+				Q931Rx43(&isdn_data->q931, gen, gen->Size);
 			}
 		}
 		break;
@@ -1268,7 +1418,7 @@ static __inline__ void state_advance(ftdm_channel_t *ftdmchan)
 		{
 			if (ftdm_test_flag(ftdmchan, FTDM_CHANNEL_OUTBOUND)) {
 				sig.event_id = FTDM_SIGEVENT_UP;
-				if ((status = ftdm_span_send_signal(ftdmchan->span, &sig) != FTDM_SUCCESS)) {
+				if ((status = isdn_data->sig_cb(&sig) != FTDM_SUCCESS)) {
 					ftdm_set_state_locked(ftdmchan, FTDM_CHANNEL_STATE_HANGUP);
 				}
 			} else {
@@ -1281,7 +1431,7 @@ static __inline__ void state_advance(ftdm_channel_t *ftdmchan)
 				gen->MesType = Q931mes_CONNECT;
 				gen->BearerCap = 0;
 				gen->CRVFlag = 1;	/* inbound call */
-				Q931Rx43(&isdn_data->q931, (void *)gen, ftdmchan->caller_data.raw_data_len);
+				Q931Rx43(&isdn_data->q931, gen, ftdmchan->caller_data.raw_data_len);
 			}
 		}
 		break;
@@ -1305,7 +1455,7 @@ static __inline__ void state_advance(ftdm_channel_t *ftdmchan)
 
 			/*
 			 * Q.931 Setup Message
-			 */ 
+			 */
 			Q931InitMesGeneric(gen);
 			gen->MesType = Q931mes_SETUP;
 			gen->CRVFlag = 0;		/* outbound(?) */
@@ -1320,7 +1470,7 @@ static __inline__ void state_advance(ftdm_channel_t *ftdmchan)
 			BearerCap.ITR       = Q931_ITR_64K;	/* 64k = 16, Packet mode = 0 */
 			BearerCap.Layer1Ident = 1;
 			BearerCap.UIL1Prot = (codec == FTDM_CODEC_ALAW) ? 3 : 2;	/* U-law = 2, A-law = 3 */
-			gen->BearerCap = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &BearerCap);
+			gen->BearerCap = Q931AppendIE(gen, (L3UCHAR *) &BearerCap);
 
 			/*
 			 * ChannelID IE
@@ -1335,7 +1485,7 @@ static __inline__ void state_advance(ftdm_channel_t *ftdmchan)
 			} else {
 				ChanID.InfoChanSel = (unsigned char)ftdmchan->chan_id & 0x03;	/* None = 0, B1 = 1, B2 = 2, Any = 3 */
 			}
-			gen->ChanID = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &ChanID);
+			gen->ChanID = Q931AppendIE(gen, (L3UCHAR *) &ChanID);
 
 			/*
 			 * Progress IE
@@ -1344,29 +1494,29 @@ static __inline__ void state_advance(ftdm_channel_t *ftdmchan)
 			Progress.CodStand = Q931_CODING_ITU;	/* 0 = ITU */
 			Progress.Location = 0;  /* 0 = User, 1 = Private Network */
 			Progress.ProgDesc = 3;	/* 1 = Not end-to-end ISDN */
-			gen->ProgInd = Q931AppendIE((L3UCHAR *)gen, (L3UCHAR *)&Progress);
+			gen->ProgInd = Q931AppendIE(gen, (L3UCHAR *)&Progress);
 
 			/*
 			 * Display IE
 			 */
-			if (!(isdn_data->opts & FTDM_ISDN_OPT_OMIT_DISPLAY_IE)) {
+			if (!(isdn_data->opts & FTDM_ISDN_OPT_OMIT_DISPLAY_IE) && FTDM_SPAN_IS_NT(ftdmchan->span)) {
 				Q931InitIEDisplay(&Display);
 				Display.Size = Display.Size + (unsigned char)strlen(ftdmchan->caller_data.cid_name);
-				gen->Display = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &Display);
+				gen->Display = Q931AppendIE(gen, (L3UCHAR *) &Display);
 				ptrDisplay = Q931GetIEPtr(gen->Display, gen->buf);
 				ftdm_copy_string((char *)ptrDisplay->Display, ftdmchan->caller_data.cid_name, strlen(ftdmchan->caller_data.cid_name)+1);
 			}
 
 			/*
 			 * CallingNum IE
-			 */ 
+			 */
 			Q931InitIECallingNum(&CallingNum);
 			CallingNum.TypNum    = ftdmchan->caller_data.ani.type;
 			CallingNum.NumPlanID = Q931_NUMPLAN_E164;
 			CallingNum.PresInd   = Q931_PRES_ALLOWED;
 			CallingNum.ScreenInd = Q931_SCREEN_USER_NOT_SCREENED;
 			CallingNum.Size = CallingNum.Size + (unsigned char)strlen(ftdmchan->caller_data.cid_num.digits);
-			gen->CallingNum = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &CallingNum);
+			gen->CallingNum = Q931AppendIE(gen, (L3UCHAR *) &CallingNum);
 			ptrCallingNum = Q931GetIEPtr(gen->CallingNum, gen->buf);
 			ftdm_copy_string((char *)ptrCallingNum->Digit, ftdmchan->caller_data.cid_num.digits, strlen(ftdmchan->caller_data.cid_num.digits)+1);
 
@@ -1374,12 +1524,12 @@ static __inline__ void state_advance(ftdm_channel_t *ftdmchan)
 			 * CalledNum IE
 			 */
 			Q931InitIECalledNum(&CalledNum);
-			CalledNum.TypNum    = ftdmchan->caller_data.dnis.type;
+			CalledNum.TypNum    = Q931_TON_UNKNOWN;
 			CalledNum.NumPlanID = Q931_NUMPLAN_E164;
-			CalledNum.Size = CalledNum.Size + (unsigned char)strlen(ftdmchan->caller_data.dnis.digits);
-			gen->CalledNum = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &CalledNum);
+			CalledNum.Size = CalledNum.Size + (unsigned char)strlen(ftdmchan->caller_data.ani.digits);
+			gen->CalledNum = Q931AppendIE(gen, (L3UCHAR *) &CalledNum);
 			ptrCalledNum = Q931GetIEPtr(gen->CalledNum, gen->buf);
-			ftdm_copy_string((char *)ptrCalledNum->Digit, ftdmchan->caller_data.dnis.digits, strlen(ftdmchan->caller_data.dnis.digits)+1);
+			ftdm_copy_string((char *)ptrCalledNum->Digit, ftdmchan->caller_data.ani.digits, strlen(ftdmchan->caller_data.ani.digits)+1);
 
 			/*
 			 * High-Layer Compatibility IE   (Note: Required for AVM FritzBox)
@@ -1389,10 +1539,24 @@ static __inline__ void state_advance(ftdm_channel_t *ftdmchan)
 			HLComp.Interpret = 4;	/* only possible value */
 			HLComp.PresMeth  = 1;   /* High-layer protocol profile */
 			HLComp.HLCharID  = Q931_HLCHAR_TELEPHONY;	/* Telephony = 1, Fax G2+3 = 4, Fax G4 = 65 (Class I)/ 68 (Class II or III) */   /* TODO: make accessible from user layer */
-			gen->HLComp = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &HLComp);
+			gen->HLComp = Q931AppendIE(gen, (L3UCHAR *) &HLComp);
 
-			Q931Rx43(&isdn_data->q931, (L3UCHAR *) gen, gen->Size);
+			Q931Rx43(&isdn_data->q931, gen, gen->Size);
 			isdn_data->channels_local_crv[gen->CRV] = ftdmchan;
+
+			/*
+			 * Support code for the new event handling system
+			 * Remove this as soon as we have the new api to set up calls
+			 */
+			if (gen->CRV) {
+				struct Q931_Call *call;
+
+				call = Q931GetCallByCRV(&isdn_data->q931, gen->CRV);
+				if (call) {
+					ftdm_log(FTDM_LOG_DEBUG, "Storing reference to current span in call %d [0x%x]\n", gen->CRV, gen->CRV);
+					Q931CallSetPrivate(call, ftdmchan->span);
+				}
+			}
 		}
 		break;
 	case FTDM_CHANNEL_STATE_HANGUP_COMPLETE:
@@ -1401,7 +1565,7 @@ static __inline__ void state_advance(ftdm_channel_t *ftdmchan)
 			if(ftdmchan->last_state == FTDM_CHANNEL_STATE_HANGUP) {
 				gen->MesType = Q931mes_RELEASE_COMPLETE;
 
-				Q931Rx43(&isdn_data->q931, (L3UCHAR *) gen, gen->Size);
+				Q931Rx43(&isdn_data->q931, gen, gen->Size);
 			}
 			ftdm_set_state_locked(ftdmchan, FTDM_CHANNEL_STATE_DOWN);
 		}
@@ -1434,8 +1598,8 @@ static __inline__ void state_advance(ftdm_channel_t *ftdmchan)
 				//cause.Value = (unsigned char) FTDM_CAUSE_UNALLOCATED;
 				cause.Value = (unsigned char) ftdmchan->caller_data.hangup_cause;
 				*cause.Diag = '\0';
-				gen->Cause = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &cause);
-				Q931Rx43(&isdn_data->q931, (L3UCHAR *) gen, gen->Size);
+				gen->Cause = Q931AppendIE(gen, (L3UCHAR *) &cause);
+				Q931Rx43(&isdn_data->q931, gen, gen->Size);
 
 				/* we're done, release channel */
 				//ftdm_set_state_locked(ftdmchan, FTDM_CHANNEL_STATE_HANGUP_COMPLETE);
@@ -1449,8 +1613,8 @@ static __inline__ void state_advance(ftdm_channel_t *ftdmchan)
 
 				cause.Value = (unsigned char) ftdmchan->caller_data.hangup_cause;
 				*cause.Diag = '\0';
-				gen->Cause = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &cause);
-				Q931Rx43(&isdn_data->q931, (void *)gen, gen->Size);
+				gen->Cause = Q931AppendIE(gen, (L3UCHAR *) &cause);
+				Q931Rx43(&isdn_data->q931, gen, gen->Size);
 
 				/* this will be triggered by the RELEASE_COMPLETE reply */
 				/* ftdm_set_state_locked(ftdmchan, FTDM_CHANNEL_STATE_HANGUP_COMPLETE); */
@@ -1463,8 +1627,8 @@ static __inline__ void state_advance(ftdm_channel_t *ftdmchan)
 
 				cause.Value = (unsigned char) ftdmchan->caller_data.hangup_cause;
 				*cause.Diag = '\0';
-				gen->Cause = Q931AppendIE((L3UCHAR *) gen, (L3UCHAR *) &cause);
-				Q931Rx43(&isdn_data->q931, (L3UCHAR *) gen, gen->Size);
+				gen->Cause = Q931AppendIE(gen, (L3UCHAR *) &cause);
+				Q931Rx43(&isdn_data->q931, gen, gen->Size);
 			}
 		}
 		break;
@@ -1473,20 +1637,16 @@ static __inline__ void state_advance(ftdm_channel_t *ftdmchan)
 			ftdm_log(FTDM_LOG_DEBUG, "Terminating: Direction %s\n", ftdm_test_flag(ftdmchan, FTDM_CHANNEL_OUTBOUND) ? "Outbound" : "Inbound");
 
 			sig.event_id = FTDM_SIGEVENT_STOP;
-			status = ftdm_span_send_signal(ftdmchan->span, &sig);
+			status = isdn_data->sig_cb(&sig);
 			gen->MesType = Q931mes_RELEASE;
 			gen->CRVFlag = ftdm_test_flag(ftdmchan, FTDM_CHANNEL_OUTBOUND) ? 0 : 1;
-			Q931Rx43(&isdn_data->q931, (void *)gen, gen->Size);
+			Q931Rx43(&isdn_data->q931, gen, gen->Size);
 		}
 	default:
 		break;
 	}
 }
 
-/**
- * \brief Checks current state on a span
- * \param span Span to check status on
- */
 static __inline__ void check_state(ftdm_span_t *span)
 {
     if (ftdm_test_flag(span, FTDM_SPAN_STATE_CHANGE)) {
@@ -1504,56 +1664,79 @@ static __inline__ void check_state(ftdm_span_t *span)
     }
 }
 
-/**
- * \brief Processes FreeTDM event on a span
- * \param span Span to process event on
- * \param event Event to process
- * \return Success or failure
- */
+
 static __inline__ ftdm_status_t process_event(ftdm_span_t *span, ftdm_event_t *event)
 {
-	ftdm_log(FTDM_LOG_DEBUG, "EVENT [%s][%d:%d] STATE [%s]\n", 
+	ftdm_isdn_data_t *isdn_data = span->signal_data;
+	ftdm_alarm_flag_t alarmbits;
+	ftdm_sigmsg_t sig;
+
+	memset(&sig, 0, sizeof(sig));
+	sig.chan_id = event->channel->chan_id;
+	sig.span_id = event->channel->span_id;
+	sig.channel = event->channel;
+
+	ftdm_log(FTDM_LOG_DEBUG, "EVENT [%s][%d:%d] STATE [%s]\n",
 			ftdm_oob_event2str(event->enum_id), event->channel->span_id, event->channel->chan_id, ftdm_channel_state2str(event->channel->state));
 
 	switch(event->enum_id) {
 	case FTDM_OOB_ALARM_TRAP:
 		{
+			sig.event_id = FTDM_OOB_ALARM_TRAP;
 			if (event->channel->state != FTDM_CHANNEL_STATE_DOWN) {
-				if (event->channel->type == FTDM_CHAN_TYPE_B) {
-					ftdm_set_state_locked(event->channel, FTDM_CHANNEL_STATE_RESTART);
-				}
+				ftdm_set_state_locked(event->channel, FTDM_CHANNEL_STATE_RESTART);
 			}
-			
-
 			ftdm_set_flag(event->channel, FTDM_CHANNEL_SUSPENDED);
-
-			
-			ftdm_channel_get_alarms(event->channel);
-			ftdm_log(FTDM_LOG_WARNING, "channel %d:%d (%d:%d) has alarms! [%s]\n", 
-					event->channel->span_id, event->channel->chan_id, 
-					event->channel->physical_span_id, event->channel->physical_chan_id, 
+			ftdm_channel_get_alarms(event->channel, &alarmbits);
+			isdn_data->sig_cb(&sig);
+			ftdm_log(FTDM_LOG_WARNING, "channel %d:%d (%d:%d) has alarms [%s]\n",
+					event->channel->span_id, event->channel->chan_id,
+					event->channel->physical_span_id, event->channel->physical_chan_id,
 					event->channel->last_error);
 		}
 		break;
 	case FTDM_OOB_ALARM_CLEAR:
 		{
-			
-			ftdm_log(FTDM_LOG_WARNING, "channel %d:%d (%d:%d) alarms Cleared!\n", event->channel->span_id, event->channel->chan_id,
-					event->channel->physical_span_id, event->channel->physical_chan_id);
-
+			sig.event_id = FTDM_OOB_ALARM_CLEAR;
 			ftdm_clear_flag(event->channel, FTDM_CHANNEL_SUSPENDED);
-			ftdm_channel_get_alarms(event->channel);
+			ftdm_channel_get_alarms(event->channel, &alarmbits);
+			isdn_data->sig_cb(&sig);
+		}
+		break;
+#ifdef __BROKEN_BY_FREETDM_CONVERSION__
+	case FTDM_OOB_DTMF:	/* Taken from ozmod_analog, minus the CALLWAITING state handling */
+		{
+			const char * digit_str = (const char *)event->data;
+
+			if(digit_str) {
+				fio_event_cb_t event_callback = NULL;
+
+				ftdm_channel_queue_dtmf(event->channel, digit_str);
+				if (span->event_callback) {
+					event_callback = span->event_callback;
+				} else if (event->channel->event_callback) {
+					event_callback = event->channel->event_callback;
+				}
+
+				if (event_callback) {
+					event->channel->event_header.channel = event->channel;
+					event->channel->event_header.e_type = FTDM_EVENT_DTMF;
+					event->channel->event_header.data = (void *)digit_str;
+					event_callback(event->channel, &event->channel->event_header);
+					event->channel->event_header.e_type = FTDM_EVENT_NONE;
+					event->channel->event_header.data = NULL;
+				}
+				ftdm_safe_free(event->data);
+			}
 		}
 		break;
+#endif
 	}
 
 	return FTDM_SUCCESS;
 }
 
-/**
- * \brief Checks for events on a span
- * \param span Span to check for events
- */
+
 static __inline__ void check_events(ftdm_span_t *span)
 {
 	ftdm_status_t status;
@@ -1584,12 +1767,7 @@ static __inline__ void check_events(ftdm_span_t *span)
 	}
 }
 
-/**
- * \brief Retrieves tone generation output to be sent
- * \param ts Teletone generator
- * \param map Tone map
- * \return -1 on error, 0 on success
- */
+
 static int teletone_handler(teletone_generation_session_t *ts, teletone_tone_map_t *map)
 {
 	ftdm_buffer_t *dt_buffer = ts->user_data;
@@ -1603,20 +1781,14 @@ static int teletone_handler(teletone_generation_session_t *ts, teletone_tone_map
 	return 0;
 }
 
-/**
- * \brief Main thread function for tone generation on a span
- * \param me Current thread
- * \param obj Span to generate tones on
- */
 static void *ftdm_isdn_tones_run(ftdm_thread_t *me, void *obj)
 {
 	ftdm_span_t *span = (ftdm_span_t *) obj;
 	ftdm_isdn_data_t *isdn_data = span->signal_data;
 	ftdm_buffer_t *dt_buffer = NULL;
-	teletone_generation_session_t ts = {{{{0}}}};
+	teletone_generation_session_t ts = {{{{0}}}};;
 	unsigned char frame[1024];
-	uint32_t x;
-	int interval = 0;
+	int x, interval;
 	int offset = 0;
 
 	ftdm_log(FTDM_LOG_DEBUG, "ISDN tones thread starting.\n");
@@ -1647,7 +1819,7 @@ static void *ftdm_isdn_tones_run(ftdm_thread_t *me, void *obj)
 	ts.duration = ts.rate;
 
 	/* main loop */
-	while(ftdm_running() && ftdm_test_flag(isdn_data, FTDM_ISDN_TONES_RUNNING) && !ftdm_test_flag(isdn_data, FTDM_ISDN_STOP)) {
+	while(ftdm_running() && ftdm_test_flag(isdn_data, FTDM_ISDN_RUNNING)) {
 		ftdm_wait_flag_t flags;
 		ftdm_status_t status;
 		int last_chan_state = 0;
@@ -1799,11 +1971,6 @@ done:
 	return NULL;
 }
 
-/**
- * \brief Main thread function for an ISDN span
- * \param me Current thread
- * \param obj Span to monitor
- */
 static void *ftdm_isdn_run(ftdm_thread_t *me, void *obj)
 {
 	ftdm_span_t *span = (ftdm_span_t *) obj;
@@ -1813,15 +1980,16 @@ static void *ftdm_isdn_run(ftdm_thread_t *me, void *obj)
 	int errs = 0;
 
 #ifdef WIN32
-    timeBeginPeriod(1);
+	timeBeginPeriod(1);
 #endif
 
 	ftdm_log(FTDM_LOG_DEBUG, "ISDN thread starting.\n");
 	ftdm_set_flag(isdn_data, FTDM_ISDN_RUNNING);
 
 	Q921Start(&isdn_data->q921);
+	Q931Start(&isdn_data->q931);
 
-	while(ftdm_running() && ftdm_test_flag(isdn_data, FTDM_ISDN_RUNNING) && !ftdm_test_flag(isdn_data, FTDM_ISDN_STOP)) {
+	while(ftdm_running() && ftdm_test_flag(isdn_data, FTDM_ISDN_RUNNING)) {
 		ftdm_wait_flag_t flags = FTDM_READ;
 		ftdm_status_t status = ftdm_channel_wait(isdn_data->dchan, &flags, 100);
 
@@ -1853,20 +2021,13 @@ static void *ftdm_isdn_run(ftdm_thread_t *me, void *obj)
 			{
 				errs = 0;
 				if (flags & FTDM_READ) {
-
-					if (ftdm_test_flag(isdn_data->dchan, FTDM_CHANNEL_SUSPENDED)) {
-						ftdm_clear_flag_all(span, FTDM_CHANNEL_SUSPENDED);
-					}
 					len = sizeof(frame);
 					if (ftdm_channel_read(isdn_data->dchan, frame, &len) == FTDM_SUCCESS) {
-#ifdef IODEBUG
-						char bb[4096] = "";
-						print_hex_bytes(frame, len, bb, sizeof(bb));
-
-						print_bits(frame, (int)len, bb, sizeof(bb), FTDM_ENDIAN_LITTLE, 0);
-						ftdm_log(FTDM_LOG_DEBUG, "READ %d\n%s\n%s\n\n", (int)len, LINE, bb);
+#ifdef HAVE_PCAP
+						if (isdn_pcap_capture_both(isdn_data)) {
+							isdn_pcap_write(isdn_data, frame, len, ISDN_PCAP_INCOMING);
+						}
 #endif
-
 						Q921QueueHDLCFrame(&isdn_data->q921, frame, (int)len);
 						Q921Rx12(&isdn_data->q921);
 					}
@@ -1877,45 +2038,28 @@ static void *ftdm_isdn_run(ftdm_thread_t *me, void *obj)
 			break;
 		}
 	}
-	
- done:
+
+done:
 	ftdm_channel_close(&isdn_data->dchans[0]);
 	ftdm_channel_close(&isdn_data->dchans[1]);
 	ftdm_clear_flag(isdn_data, FTDM_ISDN_RUNNING);
 
 #ifdef WIN32
-    timeEndPeriod(1);
+	timeEndPeriod(1);
+#endif
+#ifdef HAVE_PCAP
+	if (isdn_pcap_is_open(isdn_data)) {
+		isdn_pcap_close(isdn_data);
+	}
 #endif
-
 	ftdm_log(FTDM_LOG_DEBUG, "ISDN thread ended.\n");
 	return NULL;
 }
 
-/**
- * \brief FreeTDM ISDN signaling module initialisation
- * \return Success
- */
-static FIO_SIG_LOAD_FUNCTION(ftdm_isdn_init)
-{
-	Q931Initialize();
-
-	Q921SetGetTimeCB(ftdm_time_now);
-	Q931SetGetTimeCB(ftdm_time_now);
-
-	return FTDM_SUCCESS;
-}
-
-/**
- * \brief Receives a Q931 indication message
- * \param pvt Span were message is coming from
- * \param ind Q931 indication
- * \param tei Terminal Endpoint Identifier
- * \param msg Message string
- * \param mlen Message string length
- * \return 0 on success
- */
 static int q931_rx_32(void *pvt, Q921DLMsg_t ind, L3UCHAR tei, L3UCHAR *msg, L3INT mlen)
 {
+	ftdm_span_t *span = pvt;
+	ftdm_isdn_data_t *isdn_data = span->signal_data;
 	int offset = 4;
 	char bb[4096] = "";
 
@@ -1925,16 +2069,6 @@ static int q931_rx_32(void *pvt, Q921DLMsg_t ind, L3UCHAR tei, L3UCHAR *msg, L3I
 
 	case Q921_DL_DATA:
 		print_hex_bytes(msg + offset, mlen - offset, bb, sizeof(bb));
-#ifdef HAVE_LIBPCAP
-		/*Q931ToPcap*/
-		if(do_q931ToPcap==1){
-			ftdm_span_t *span = (ftdm_span_t *) pvt;
-			if(writeQ931PacketToPcap(msg + offset, mlen - offset, span->span_id, 0) != FTDM_SUCCESS){
-				ftdm_log(FTDM_LOG_WARNING, "Couldn't write Q931 buffer to pcap file!\n");	
-			}
-		}
-		/*Q931ToPcap done*/
-#endif
 		ftdm_log(FTDM_LOG_DEBUG, "WRITE %d\n%s\n%s\n\n", (int)mlen - offset, LINE, bb);
 		break;
 
